/* Copyright 2004-2005 Graeme Rocher
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.codehaus.groovy.grails.web.servlet;

/**
 *
 * Class containing constants for HTTP headers.
 * 
 * @author Graeme Rocher
 * @since 1.0
 *        <p/>
 *        Created: Nov 21, 2007
 */
public class HttpHeaders {
    public static final java.lang.String CONNECTION = "Connection";
    public static final java.lang.String CACHE_CONTROL = "Cache-Control";
    public static final java.lang.String DATE = "Date";
    public static final java.lang.String PRAGMA = "Pragma";
    public static final java.lang.String PROXY_CONNECTION = "Proxy-Connection";
    public static final java.lang.String TRAILER = "Trailer";
    public static final java.lang.String TRANSFER_ENCODING = "Transfer-Encoding";
    public static final java.lang.String UPGRADE = "Upgrade";
    public static final java.lang.String VIA = "Via";
    public static final java.lang.String WARNING = "Warning";
    public static final java.lang.String ALLOW = "Allow";
    public static final java.lang.String CONTENT_ENCODING = "Content-Encoding";
    public static final java.lang.String CONTENT_LANGUAGE = "Content-Language";
    public static final java.lang.String CONTENT_LENGTH = "Content-Length";
    public static final java.lang.String CONTENT_LOCATION = "Content-Location";
    public static final java.lang.String CONTENT_MD5 = "Content-MD5";
    public static final java.lang.String CONTENT_RANGE = "Content-Range";
    public static final java.lang.String CONTENT_TYPE = "Content-Type";
    public static final java.lang.String EXPIRES = "Expires";
    public static final java.lang.String LAST_MODIFIED = "Last-Modified";
    public static final java.lang.String ACCEPT = "Accept";
    public static final java.lang.String ACCEPT_CHARSET = "Accept-Charset";
    public static final java.lang.String ACCEPT_ENCODING = "Accept-Encoding";
    public static final java.lang.String ACCEPT_LANGUAGE = "Accept-Language";
    public static final java.lang.String AUTHORIZATION = "Authorization";
    public static final java.lang.String EXPECT = "Expect";
    public static final java.lang.String FORWARDED = "Forwarded";
    public static final java.lang.String FROM = "From";
    public static final java.lang.String HOST = "Host";
    public static final java.lang.String IF_MATCH = "If-Match";
    public static final java.lang.String IF_MODIFIED_SINCE = "If-Modified-Since";
    public static final java.lang.String IF_NONE_MATCH = "If-None-Match";
    public static final java.lang.String IF_RANGE = "If-Range";
    public static final java.lang.String IF_UNMODIFIED_SINCE = "If-Unmodified-Since";
    public static final java.lang.String KEEP_ALIVE = "Keep-Alive";
    public static final java.lang.String MAX_FORWARDS = "Max-Forwards";
    public static final java.lang.String PROXY_AUTHORIZATION = "Proxy-Authorization";
    public static final java.lang.String RANGE = "Range";
    public static final java.lang.String REQUEST_RANGE = "Request-Range";
    public static final java.lang.String REFERER = "Referer";
    public static final java.lang.String TE = "TE";
    public static final java.lang.String USER_AGENT = "User-Agent";
    public static final java.lang.String X_FORWARDED_FOR = "X-Forwarded-For";
    public static final java.lang.String ACCEPT_RANGES = "Accept-Ranges";
    public static final java.lang.String AGE = "Age";
    public static final java.lang.String ETAG = "ETag";
    public static final java.lang.String LOCATION = "Location";
    public static final java.lang.String PROXY_AUTHENTICATE = "Proxy-Authenticate";
    public static final java.lang.String RETRY_AFTER = "Retry-After";
    public static final java.lang.String SERVER = "Server";
    public static final java.lang.String SERVLET_ENGINE = "Servlet-Engine";
    public static final java.lang.String VARY = "Vary";
    public static final java.lang.String WWW_AUTHENTICATE = "WWW-Authenticate";
    public static final java.lang.String COOKIE = "Cookie";
    public static final java.lang.String SET_COOKIE = "Set-Cookie";
    public static final java.lang.String SET_COOKIE2 = "Set-Cookie2";
    public static final java.lang.String MIME_VERSION = "MIME-Version";
    public static final java.lang.String IDENTITY = "identity";    
}
